--- nrpe.c.old	2003-10-18 21:26:28.000000000 +0200
+++ nrpe.c	2003-10-18 21:43:08.000000000 +0200
@@ -77,6 +77,7 @@
 int     show_version=FALSE;
 int     use_inetd=TRUE;
 int     debug=FALSE;
+int     stay_in_foreground=FALSE;
 
 #ifdef HAVE_SSL
 SSL_METHOD *meth;
@@ -231,6 +232,19 @@
 		handle_connection(0);
 	        }
 
+	/* if we're running in the foreground... */
+	else if (stay_in_foreground==TRUE){
+
+		/* drop privileges */
+		drop_privileges(nrpe_user,nrpe_group);
+
+		/* make sure we're not root */
+		check_privileges();
+
+		/* wait for connections */
+		wait_for_connections();
+		}
+
 	/* else daemonize and start listening for requests... */
 	else if(fork()==0){
 
@@ -1447,6 +1461,7 @@
 	static struct option long_options[]={
 		{"config", required_argument, 0, 'c'},
 		{"inetd", no_argument, 0, 'i'},
+		{"foreground", no_argument, 0, 'f'},
 		{"daemon", no_argument, 0, 'd'},
 		{"no-ssl", no_argument, 0, 'n'},
 		{"help", no_argument, 0, 'h'},
@@ -1459,7 +1474,7 @@
 	if(argc<2)
 		return ERROR;
 
-	snprintf(optchars,MAX_INPUT_BUFFER,"c:nidhl");
+	snprintf(optchars,MAX_INPUT_BUFFER,"c:nidhlf");
 
 	while(1){
 #ifdef HAVE_GETOPT_H
@@ -1495,6 +1510,9 @@
 			use_inetd=TRUE;
 			have_mode=TRUE;
 			break;
+		case 'f':
+			stay_in_foreground=TRUE;
+			break;
 		case 'n':
 			use_ssl=FALSE;
 			break;
